﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.01
@EndOfDesignText@

#Region  Project Attributes 
	
#End Region

#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public IPAddress As String = "192.168.43.47" '192.168.213.1 "10.0.2.2"   ' ip address of blue stacks
	Public PhpPath As String = $"http://${IPAddress}/test2/"$
	
	Public city1 As String
	
	Public mylat, mylon, Radius, Radius2, ScaleLat, ScaleLon As Double
	Public a1, b1 As String
	Public Bitmap2 As Bitmap
	Public Bitmap As Bitmap
	
	Public pic1 As String 'String
	'Dim m2 As Bitmap
	'Dim timerad2 As Timer
	'Dim Counter As Int
	
End Sub

Sub Globals
	Private gmap As GoogleMap
	Private MapFragment1 As MapFragment
	'Private  mylat, mylon,, Radius, Radius2 As Double  
'	Dim ContainerPanel As Panel
	Dim InfoWindowPanel As Panel
	Dim MapPanel As Panel
	Dim Markers As Map
	Dim SnippetLabel As Label
	Dim ThumbImage As ImageView
	Dim TitleLabel As Label
	Private bmp As Bitmap
	'Public city1 As String
	Private xui As XUI
	
	Dim WebViewExtras2a As WebViewExtras
	
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'mylat = NumberFormat2(Main.mylat1,0,2,2, False) '46.95
	'mylon = NumberFormat2(Main.mylon1,0,2,2, False) 'Tracker1.b
	'ToastMessageShow("mylat3 =" & "" & mylat & "" &	"mylon3 =" & "" & mylon, True)
	
	Starter.rp.CheckAndRequest(Starter.rp.PERMISSION_ACCESS_FINE_LOCATION)
	Wait For Activity_PermissionResult (Permission As String, Result As Boolean)
	If Result = False Then
		ToastMessageShow("No permission!", True)
		'Return
	End If
	
	
	Activity.LoadLayout("1")
	If MapFragment1.IsGooglePlayServicesAvailable = False Then
		ToastMessageShow("Google Play services not available.", True)
	Else
		
	'mylat = NumberFormat2(Main.mylat1,0,2,2, False) '46.95
	'mylon = NumberFormat2(Main.mylon1,0,2,2, False) 'Tracker1.b
		mylat = NumberFormat2(Tracker1.a,0,2,2, False) '46.95
		mylon = NumberFormat2(Tracker1.b,0,2,2, False) 'Tracker1.b
		ToastMessageShow("mylat3 =" & "" & mylat & "" &	"mylon3 =" & "" & mylon, True)
	
		
	End If
	
	
	
End Sub
	

Sub MapFragment1_Ready
	
	' ToastMessageShow("mylat4 =" & "" & mylat & "" &	"mylon4 =" & "" & mylon, True)
	mylat = mylat '46.95
	mylon = mylon '7.44
	
	'File.Copy(File.DirAssets, "citylist.db", File.DirDefaultExternal, "citylist.db")
	'SQL1.Initialize(File.DirDefaultExternal, "citylist.db", True)
	
	
	Radius = 1500  '500
	'ToastMessageShow(mylat & "," & mylon, True)
	Radius2 = Radius * Radius
	ScaleLat = cPI / 180 * 6371
	ScaleLon = ScaleLat * CosD(mylat)
	
	ScaleLat = ScaleLat * ScaleLat
	ScaleLon = ScaleLon * ScaleLon
 ' With code below, i am trying to pass these variables to php when executing in SQL query
	Dim job As HttpJob
	job.Initialize("job", Me)
	job.PostString("http://192.168.43.47/test2/map1.php","scaleLat =scaleLat&scaleLon = scaleLon&Radius2 = Radius2&mylat = mylat&mylon = mylon")
	

	'To send these variables to php + mylat, mylon
	Dim straction As String = "mapfrag"
	'establish a connection to the php server
	'the field names should match fields in table
	Dim dbAction As Map
	dbAction.Initialize
	dbAction.Put("action=", straction)
	ExecutePHP(Me,dbAction, straction,"map1.php","")
	
	
	
End Sub


 
Sub InfoWindow_click(m1 As Marker)
		
	Dim misnippet As String = m1.Snippet
	
	Dim straction As String = "infowinclick"
	Dim dbAction As Map
	dbAction.Initialize
	dbAction.Put("action=", straction)
	dbAction.Put("usermisnippet=", misnippet)
	ExecutePHP(Me,dbAction, straction,"map1.php","")
	
	
End Sub




Sub InfoWindowAdapter1_GetInfoContents(M1 As Marker) As View
	TitleLabel.Text=M1.Title ' & CRLF & city1
	SnippetLabel.Text=M1.Snippet
	
	Dim misnippet1 As String = M1.Snippet
	
	Dim straction As String = "infowindowadapter"
	Dim dbAction As Map
	dbAction.Initialize
	dbAction.Put("action=", straction)
	dbAction.Put("usermisnippet1=", misnippet1)
	ExecutePHP(Me,dbAction, straction,"map1.php","")
	
	
	Return  InfoWindowPanel
	
End Sub

' i should activate this if i want to handle clicking event for marker instead of default display of infowindow when clicked 
'Sub MapFragment1_markerclick(selectedmarker As Marker) As Boolean
	'ToastMessageShow("You just click on" & city1, True)
	'Return True
'End Sub



Sub Activity_Resume
	
	'StartActivity(Me)
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	
End Sub


'execute a php call
Sub ExecutePHP(frm As Object, pQuery As Map, JobName As String, phpFile As String, phpTag As String)
	ProgressDialogShow2("Communicating with the server...",False)
	Dim job As HttpJob
	Dim scommand As String
	Dim json As String
	'initialize a new job that will run from a class object
	job.Initialize(JobName, frm)
	job.Tag = phpTag
	json = Map2QueryString(pQuery)
	If Len(json) = 0 Then
		scommand = $"${PhpPath}${phpFile}"$
	Else
		scommand = $"${PhpPath}${phpFile}?${json}"$
	End If
	'execute a download on the php file
	job.Download(scommand)
End Sub

'convert a map to a querystring
Sub Map2QueryString(sm As Map) As String
	' convert a map to a querystring string
	Dim SU As StringUtils
	Dim iCnt As Int
	Dim iTot As Int
	Dim sb As StringBuilder
	Dim mValue As String
	sb.Initialize
	
	' get size of map
	iTot = sm.Size - 1
	iCnt = 0
	For Each mKey As String In sm.Keys
		mValue = sm.Getdefault(mKey,"")
		mValue = mValue.trim
		mValue = SU.EncodeUrl(mValue, "UTF8")
		mKey = mKey.Trim
		If mKey.EndsWith("=") = False Then mKey = mKey & "="
		sb.Append(mKey).Append(mValue)
		If iCnt < iTot Then sb.Append("&")
		iCnt = iCnt + 1
	Next
	Return sb.ToString
End Sub

'convert a json string to a list
Sub Json2List(jsonTxt As String) As List
	Dim root As List
	root.Initialize
	Try
		Dim parser As JSONParser
		parser.Initialize(jsonTxt)
		root = parser.NextArray
		Return root
	Catch
		Return root
	End Try
End Sub

'get the length of the string
Sub Len(Text As String) As Int
	Return Text.Length
End Sub

'when a job is done
Sub JobDone (Job As HttpJob)
	ProgressDialogHide
	If Job.Success = True Then
		Dim jobResult As String = Job.GetString
		Dim jobTag As String = Job.tag
		Job.release
		'convert json string to list
		Dim res As List = Json2List(jobResult)
		Select Job.JobName
		
			Case "mapfrag"
			
				If res.Size = 0 Then
					Msgbox("Mapfrag could NOT be populated successfully, please try again!","Error")
				Else
					For i = 0 To res.Size-1
						Dim user_map As Map
						user_map = res.Get(i)
						Dim lat As Double = user_map.Get("userlatitude")
						Dim lon As Double = user_map.Get("userlongitude")
						Dim surname As String = user_map.Get("usersurname")
						Dim firstname As String = user_map.Get("userfname")
						Dim sex As String = user_map.Get("usersex")
						Dim distance As String = user_map.Get("userdistance")
						Dim pic1 As String = user_map.Get("userpic")
						
						'ToastMessageShow(lat & lon & surname & firstname,True)
						'Log(surname)
						'Log(firstname)
						'Log(sex)
						'spnReligion.Add(name)
						
						Dim su As StringUtils
						Dim Buffer() As Byte = su.DecodeBase64(pic1)
						Dim in As InputStream
						in.InitializeFromBytesArray(Buffer, 0, Buffer.Length)
						Dim bitmap1 As Bitmap
						bitmap1.Initialize2(in)
						in.Close
		
		
		
						Bitmap = bitmap1
						'for using single image as custom marker
						'bmp = LoadBitmapResize(File.DirAssets, "2.jpg",32dip, 32dip, True)
						' for using database different images for each custom marker on map
						Dim bmp1 As Bitmap
						bmp1 = bitmap1.Resize(64dip,64dip, True) '32
						
		
						gmap = MapFragment1.GetMap
						If gmap.IsInitialized = False Then
							ToastMessageShow("Error initializing map.", True)
						Else
							'gmap.MyLocationEnabled = True
			
							Dim GoogleMapsExtras1 As GoogleMapsExtras
							Dim InfoWindowAdapter1 As InfoWindowAdapter
		
							InfoWindowAdapter1.Initialize("InfoWindowAdapter1")
							GoogleMapsExtras1.SetInfoWindowAdapter(gmap, InfoWindowAdapter1)
		
							InfoWindowPanel.Initialize("")
							InfoWindowPanel.LoadLayout("InfoWindow")
							'	 a hack(ish) way to set InfoWindowPanel width and height!
							MapPanel.AddView(InfoWindowPanel, 0, 0, 300dip, 145dip)
							InfoWindowPanel.RemoveView
		
			
							city1 = surname & " " & firstname & CRLF & sex & CRLF & "She is" & " " & distance & "km" & " " & "from you" 'city1 - global variable. This is used to concatenate more database data to show on map
							Markers.Initialize
		
							Dim m1 As Marker = gmap.AddMarker3(lat, lon, city1 ,bmp1) 'bmp
			
							m1.Snippet = surname
			 
			
							Markers.Put(m1, m1)
			
							Dim cp As CameraPosition
							cp.Initialize(mylat, mylon,8.0) '5.9
							gmap.AnimateCamera(cp)
			
						End If
		
						Sleep(0)
					Next
					
				
				'To click on InfoWindow, setup listener as this	and handle its click event
				Dim oi As OnInfoWindowClickListener
					oi.Initialize("InfoWindow")
					GoogleMapsExtras1.SetOnInfoWindowClickListener(gmap, oi)
				End If
			Case "infowinclick"
				
			
				If res.Size = 0 Then
					Msgbox("infowinclick could NOT be populated successfully, please try again!","Error")
				Else'
					For i = 0 To res.Size-1
						Dim user_map As Map
						user_map = res.Get(i)
						Dim lat As Double = user_map.Get("userlatitude")
						Dim lon As Double = user_map.Get("userlongitude")
						Dim surname As String = user_map.Get("usersurname")
						Dim firstname As String = user_map.Get("userfname")
						Dim sex As String = user_map.Get("usersex")
						Dim distance As String = user_map.Get("userdistance")
						Dim pic1 As String = user_map.Get("userpic")
						
												Sleep(0)
					Next
					
					ToastMessageShow(surname & " " & " " & firstname, True)
					
				End If
			
			Case "infowindowadapter"
							
				If res.Size = 0 Then
					Msgbox("infowindowadapter could NOT be populated successfully, please try again!","Error")
				Else'
					For i = 0 To res.Size-1
						Dim user_map As Map
						user_map = res.Get(i)
						Dim lat As Double = user_map.Get("userlatitude")
						Dim lon As Double = user_map.Get("userlongitude")
						Dim surname As String = user_map.Get("usersurname")
						Dim firstname As String = user_map.Get("userfname")
						Dim sex As String = user_map.Get("usersex")
						Dim distance As String = user_map.Get("userdistance")
						Dim pic1 As String = user_map.Get("userpic")
						
						Dim su As StringUtils
						Dim Buffer() As Byte = su.DecodeBase64(pic1)
						Dim in As InputStream
						in.InitializeFromBytesArray(Buffer, 0, Buffer.Length)
						Dim bitmap1 As Bitmap
						bitmap1.Initialize2(in)
						in.Close
						
						ThumbImage.Bitmap = bitmap1
		
		
						Sleep(0)
					Next
					
				End If
		End Select
	Else
		Log(Job.ErrorMessage)
	End If
	Job.release
End Sub
